<template>
    <div class="w-full">
        <span class="text-gray-700 pb-3 flex items-center">
            {{label}}
        </span>

        <div class="w-full border border-grey-light shadow-sm rounded-t-lg">
            <div class="overflow-x-auto table-responsive rounded-t-lg">
                <!-- Table -->
                <table class="mx-auto w-full whitespace-nowrap overflow-x-hidden ">
                    <thead class="text-white border-b-2 border-grey-light">
                    <tr class="bg-gray-800 text-left border-b-1">

                        <th class="py-3 px-4 uppercase font-semibold text-sm" v-if="enableSelect"></th>
                        <th v-for="(item, index) in columns" :key="index"
                            class=" py-3 px-4 uppercase font-semibold text-sm">
                            {{ item.text }}
                        </th>
                        <th class=" py-3 px-4 uppercase font-semibold text-sm" v-if="actions.length > 0">
                            Action
                        </th>
                    </tr>
                    </thead>

                    <template v-if="data.length > 0">
                        <tbody class="divide-y divide-gray-200  divide-bg-gray-200">
                            <tr v-for="(item, rowIndex) in data" :key="rowIndex" class="hover:bg-gray-300 items-center" :class="getRowBg(rowIndex)">
                                <td class="px-3 py-4 whitespace-no-wrap" v-if="enableSelect">
                                    <input type="checkbox" @input="checkChanged($event, item)"/>
                                </td>

                                <template v-for="key in columns">
                                    <td class="px-4 py-3 whitespace-no-wrap">
                                        <template v-if="key.name !== undefined">

                                            <template v-if="key.name.split('.').length > 0">
                                                <p class="text-sm leading-5">
                                                    {{getNestedValue(key.name.split("."), item) === undefined ? "" :
                                                    getNestedValue(key.name.split("."), item) }}
                                                </p>
                                            </template>

                                        </template>

                                        <template v-else>
                                            <p class="text-sm" v-if="key.name">
                                                <template>
                                                    {{ item[key.name] === undefined ? "" : item[key.name] }}
                                                </template>
                                            </p>
                                            <template v-if="!key.name">
                                                <div v-html="key.render(item, rowIndex)"></div>
                                            </template>
                                        </template>
                                    </td>
                                </template>

                                <template v-if="actions.length > 0">
                                    <td class="px-4 py-3 whitespace-no-wrap text-right items-center flex flex-row">
                                        <template v-for="itemAction in actions">
                                            <div>
                                                <template v-if="itemAction.text !== undefined">
                                                    <div>
                                                        <a href="#"
                                                           @click.prevent="itemAction.action(item, rowIndex)"
                                                           :class="itemAction.class === '' || itemAction.class === undefined ? 'text-sm leading-5 text-blue-500 hover:text-indigo-900 ml-2' : itemAction.class"
                                                           v-html="itemAction.text"
                                                        >
                                                        </a>
                                                    </div>
                                                </template>

                                                <template v-else>
                                                    <div v-html="itemAction.render(item, rowIndex)"></div>
                                                </template>
                                            </div>
                                        </template>
                                    </td>
                                </template>
                            </tr>
                        </tbody>
                    </template>
                </table>

                <template v-if="data.length <= 0">
                    <div class="flex justify-center items-center">
                        <p class="py-3 text-center">No Record Found</p>
                    </div>
                </template>
            </div>
        </div>

        <template v-if="paginationLinks.length > 0 && data.length > 0">
            <Pagination
                    :links="paginationLinks"
                    :pagination-data="paginationData"
                    @click="getLink"
                    wrapper-class="lg:relative rounded-b-lg"
            ></Pagination>
        </template>


    </div>
</template>

<script>
    import Pagination from "./Pagination";

    export default {
        name: "TableList",
        components: {Pagination},
        props: {
            enableSelect: {
                type: Boolean,
                default: false
            },
            columns: {
                type: Array,
                default: () => {
                    return [];
                }
            },
            data: {
                type: Array,
                default: () => {
                    return [];
                }
            },
            actions: {
                type: Array,
                default: function () {
                    return [];
                }
            },
            paginationLinks: {
                type: Array,
                default: function () {
                    return [];
                }
            },
            paginationData: {
                type: Object,
                default: null
            },
            label: {
                type: String,
                default: ''
            }
        },
        data() {
            return {
                selectedData: []
            };
        },
        methods: {
            getRowBg(index) {
                if (index % 2 === 0) {
                    return ''
                } else {
                    return 'bg-gray-200'
                }
            },
            checkChanged(event, item) {
                let currObject = {
                    checked: event.target.checked,
                    item: item
                };

                this.$emit("tick", currObject);
            },
            getNestedValue(nestedKey, row) {
                let value = "";
                let that = this;
                nestedKey.forEach(function (item, index) {
                    if (index === 0) {
                        if(row[item] === 'Call for price'){
                            value = that.$t('call_for_price')
                        }else{
                            value = row[item] === null ? "" : row[item];
                        }

                    } else {

                        if(value[item] === 'Call for price'){
                            value = that.$t('call_for_price')
                        }else{
                            value = value[item] === null ? "" : value[item];
                        }
                    }
                });

                return value;
            },
            getLink(e) {
                this.$emit("paginationClick", e);
            }
        }
    };
</script>

<style scoped></style>
